#include <stdio.h>
#include <string.h>
#include <ctype.h>


char strlst(string)
char *string;
{
	while (*string != '\0') { if (*(string+1) == '\0') return(*string); string++;}
	return('\0');
}

int trim(s)
char *s;

{
        char *c;
 
        while (isspace(*(s + strlen(s) - 1)))    
                *(s + strlen(s) - 1) = '\0';  
 
        c = s; 
 
        while (*c == ' ' && (*c != '\0'))
                *c++ = *(c + 1);    
 
        strcpy(s, c); 
 
	return 1;

}
/* ---------------------------------------------------------------------- */
int str_isnum(s)
char *s;

{
	while(*s)
		if (!isdigit(*s++))
			return 0;

	return 1;

}

/* ---------------------------------------------------------------------- */
/* split() will parse a string into components, based on the fs parameter
 * The fs param is very specific, space is space, tab is tab, etc
 * Always call fuse() when done
 */

int split(s, parts, fs)
char *s;        	/* thing to split */
char ***parts;   	/* put parts into */
char *fs;       	/* field separator */
 
{
 
        int n, i;
        char wrkstr[512];
	char *ch_ptr;

	i = 0;
 
        /* check for in bounds */
        if (strlen(s) > sizeof(wrkstr))
        {
                fprintf(stderr, "split(): too big to split - string= %s\n", s);
                return 0;
        }
        
        /* determine how many "parts" will be split */
	if (strlen(s) == 0)
		return 0;

	strcpy(wrkstr, s);

	n = 0;	/* always at least one part unless null string */

	ch_ptr = strtok(wrkstr, fs);

	while (ch_ptr != NULL)
	{
		n++;
		ch_ptr = strtok(NULL, fs);
	}

        *parts = (char **)malloc(n * sizeof(char *));

	if (*parts == NULL)
        {
                fprintf(stderr, "split(), unable to malloc\n");
                return 0;
        }

	strcpy(wrkstr, s);
       
        ch_ptr = strtok(wrkstr, fs);

	do 
        {
                (*parts)[i] = (char *)malloc(strlen(ch_ptr) + 1);

		
                if ((*parts)[i] == NULL)
                {
                        fprintf(stderr, "split(), unable to malloc\n");
                        return i;
                }

		strcpy((*parts)[i], ch_ptr);

		i++; 

		if (i > n)
		{
			fprintf(stderr, "split(), got \"splitting\" headache, not tonight dear!\n");
			break;
		}

                ch_ptr = strtok(NULL, fs);

        } while (ch_ptr != NULL);

	/* make check for i < n, not sure why this would happen */
	if (i < n)
	{

		*parts = (char **)realloc(*parts, i * sizeof(char *));
	} 

        return i;
}

int fuse(parts, count)
char ***parts;
int count;

{
	int i;
	
	for (i = 0; i < count; i++)
		free((*parts)[i]);

	if (count > 0)
		free(*parts);

	*parts = 0;

	return 0;

}

/* ------------------------------------------------------------------- */

